
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>oracle复习笔记之PL/SQL程序所要了解的知识点_oracle / iVAN</title>

    <meta name="description" content="oracle复习笔记之PL/SQL程序所要了解的知识点_oracle 复习内容: PL/SQL的基本语法.记录类型.流程控制.游标的使用. 异常处理机制.存储函数/存储过程.触发器. 为方便大家跟着我的笔记练习,为此提供数据库表文件给大家下载:点我下载 为了要有输出的结果,在写PL/SQL程序前都在先运行这一句:set serveroutput on 结构:declare --声明变量.类型.游标begin --程序的执行部分(类似于java里的main()方法)exception --针对begin块中出现的异常,提供处理的机制 --when...then...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">oracle复习笔记之PL/SQL程序所要了解的知识点_oracle</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p><strong>复习内容：</strong></p>
<p>PL/SQL的基本语法、记录类型、流程控制、游标的使用、</p>
<p>异常处理机制、存储函数/存储过程、触发器。</p>
<p><strong>为方便大家跟着我的笔记练习，为此提供数据库表文件给大家下载：</strong>点我下载</p>
<p>为了要有输出的结果，在写PL/SQL程序前都在先运行这一句：<br /><strong>set serveroutput on</strong><br />
结构：<br />declare<br />
--声明变量、类型、游标<br />begin<br />
--程序的执行部分（类似于java里的main()方法）<br />exception<br />
--针对begin块中出现的异常，提供处理的机制<br />
--when...then...<br />
--when...then...<br />end;<br />
举例1：</p>
<pre>
declare
  v_sal number(10); （注意每句话后面别忘记了分号，跟java中的一样）
begin
  select salary into v_sal from employees where employee_id = 100;
  dbms_output.put_line(v_sal);
end;
</pre>
<p>举例2：</p>
<pre>
declare
  v_sal number(10); （注意，这里声明的空间大小不能比原表中的小）
  v_email varchar2(20);
  v_hire_date date;
begin
  select salary,email,hire_date into v_sal,v_email,v_hire_date from employees where employee_id =
100;
  dbms_output.put_line(v_sal||','||v_email||','||v_hire_date);
end;
或者：
declare
  v_sal employees.salary%type;
  v_email employees.email%type;
  v_hire_date employees.hire_date%type;
begin
  select salary,email,hire_date into v_sal,v_email,v_hire_date from employees where employee_id =
100;
  dbms_output.put_line(v_sal||','||v_email||','||v_hire_date);
end;
</pre>
<p>记录：</p>
<pre>
declare
  type emp_record is record(
   v_sal employees.salary%type,
   v_email employees.email%type,
   v_hire_date employees.hire_date%type
  );
  v_emp_record emp_record;
begin
  select salary,email,hire_date into v_emp_record from employees where employee_id = 100;
  dbms_output.put_line(v_emp_record.v_sal||','||v_emp_record.v_email||','||
  v_emp_record.v_hire_date);
end;
</pre>
<p>1、pl/sql基本的语法格式<br />
2、记录类型 type ... is ...record(,,,);<br />
3、流程控制：<br />
3.1 条件判断（两种）<br />
方式一： if ... then elseif then ... else ... end if;<br />
方式二： case ... when ... then ...end;<br />
3.2 循环结构（三种）<br />
方式一：loop ... exit when ... end loop;<br />
方式二：while ... loop ... end loop;<br />
方式三：for i in ... loop ... end loop;<br />
3.3 goto、exit<br />
4.游标的使用（类似于java中的Iterator）<br />
5.异常的处理</p>
<p>6.会写一个存储函数（有返回值）、存储过程（没有返回值）<br />
7.会写一个触发器</p>
<p>复习记录类型：</p>
<pre>
declare
type emp_record is record(
  -- v_emp_id employees.employee_id%type,
  -- v_sal employees.salary%type
  v_emp_id number(10) := 120,
  v_sal number(10,2) :=12000
);
  v_emp_record emp_record;
begin
  -- select employee_id,salary into v_emp_record from employees where employee_id = 123;
  dbms_output.put_line('employee_id:'||v_emp_record.v_emp_id||' '||'salary:'||
  v_emp_record.v_sal);
end;
</pre>
<p>也可以升级一下，要是想对表的所有列都输出，则：（须注意输出的列名要跟表中的列名要一样）</p>
<pre>
declare
  v_emp_record employees%rowtype;
begin
  select * into v_emp_record from employees where employee_id = 123;
  dbms_output.put_line('employee_id:'||v_emp_record.employee_id||' '||'salary:'||
  v_emp_record.salary);
end;
使用记录来执行update操作：
declare
  v_emp_id number(10);
begin
  v_emp_id :=123;
  update employees
  set salary = salary + 100
  where employee_id = v_emp_id;
  dbms_output.put_line('执行成功！~~');
end;
</pre>
<p><strong>流程控制：</strong><br />
查询150号员工的工资，若其工资大于或等于10000 则打印‘salary &gt;= 10000';<br />
若在5000到10000之间，则打印‘5000 &lt;= salary &lt;10000';否则打印‘salary &lt; 5000'</p>
<pre>
declare
  v_sal employees.salary%type;
begin
  select salary into v_sal from employees where employee_id =150;
  if v_sal &gt;= 10000 then dbms_output.put_line('salary &gt;= 10000');
  elsif v_sal &gt; 5000 then dbms_output.put_line('10000 &gt; salary &gt;= 5000');
  else dbms_output.put_line('salary &lt; 5000');
  end if;
  dbms_output.put_line('salary:'||v_sal);
end;
利用case ... when ... then ... when ...then ... else ... end实现上题;
declare
  v_sal employees.salary%type;
  v_temp varchar2(20);
begin
  select salary into v_sal from employees where employee_id =150;
  v_temp :=
  case trunc(v_sal/5000) when 0 then 'salary &lt; 5000'
                  when 1 then '5000 &lt;= salary &lt; 10000'
                  else 'salary &gt;= 10000'
                  end;
  dbms_output.put_line('salary:'||v_sal||' '||v_temp);
end;
</pre>
<p>查询出122号员工的job_id,若其值为 ‘IT_PROG', 则打印‘GRADE:A'<br />
                                                ‘AC_MGT', 则打印‘GRADE:B'<br />
                                                ‘AC_ACCOUNT', 则打印‘GRADE:B'<br />
                                                 否则打印‘GRADE:D'</p>
<pre>
declare
  v_job_id employees.job_id%type;
  v_temp varchar2(20);
begin
  select job_id into v_job_id from employees where employee_id =122;
  v_temp :=
  case v_job_id when 'IT_PROG' then 'A'
            when 'AC_MGT' then 'B'
            when 'AC_ACCOUNT' then 'C'
            else 'D'
            end;
  dbms_output.put_line('job_id:'||v_job_id||' '||v_temp);
end;
</pre>
<p>使用循环语句打印：1-100</p>
<pre>
declare
  v_i number(5) :=1;

begin
  loop
  dbms_output.put_line(v_i);
  exit when v_i &gt;=100;
  v_i := v_i + 1;
  end loop;
end;
使用while实现：
declare
  v_i number(5) :=1;
begin
  while v_i &lt;= 100 loop
   dbms_output.put_line(v_i);
   v_i := v_i + 1;
  end loop;
end;
使用for...in...loop...end loop;实现：
begin
  for c in 1..100 loop
   dbms_output.put_line(c);
  end loop;
end;
</pre>
<p><strong>输出2-100之间的质数</strong></p>
<pre>
declare
  v_i number(3):= 2;
  v_j number(3):= 2;
  v_flag number(1):= 1;
begin
  while v_i&lt;=100 loop
   while v_j&lt;=sqrt(v_i) loop
    if mod(v_i,v_j)=0 then v_flag:=0;
    end if;
    v_j:= v_j+1;
   end loop;
  if v_flag = 1 then dbms_output.put_line(v_i);
  end if;
  v_j :=2;
  v_i := v_i + 1;
  v_flag := 1;
  end loop;
end;
</pre>
<p>利用for循环实现输出2-100之间的质数：</p>
<pre>
declare
  v_flag number(1):= 1;
begin
  for v_i in 2..100 loop
   for v_j in 2..sqrt(v_i) loop
    if mod(v_i,v_j)=0 then v_flag:=0;
    end if;
   end loop;
   if v_flag=1 then dbms_output.put_line(v_i);
   end if;
   v_flag := 1;
  end loop;
end;
</pre>
<p>可以用goto改进一下：</p>
<pre>
declare
  v_flag number(1):= 1;
begin
  for v_i in 2..100 loop
    for v_j in 2..sqrt(v_i) loop
     if mod(v_i,v_j)=0 then v_flag:=0;
     goto label;
     end if;
   end loop;
   &lt;&lt;label&gt;&gt;
   if v_flag=1 then dbms_output.put_line(v_i);
   end if;
   v_flag := 1;
  end loop;
end;
</pre>
<p>打印1-100的自然数，当打印到50时，跳出循环 ，输出‘打印结束'：</p>
<pre>
begin
  for i in 1..100 loop
   if i=50 then goto label;
   end if;
  dbms_output.put_line(i);
  end loop;
&lt;&lt;label&gt;&gt;
  dbms_output.put_line('打印结束');
end;
或者：
begin
  for i in 1..100 loop
   if i=50 then dbms_output.put_line('打印结束');
   exit;
   end if;
  dbms_output.put_line(i);
  end loop;
end;
</pre>
<p> </p>
<p><strong>游标：</strong><br />
打印出80部门的所有的员工的工资：salary:XXX<br />
declare<br />
v_sal employees.salary%type;<br />--定义游标<br /><strong>cursor</strong> emp_sal_cursor <strong>is select</strong> salary from employees where department_id = 80;<br />
begin <br />--打开游标<br /><strong>open</strong> emp_sal_cursor;<br />--提取游标<br /><strong>fetch</strong> emp_sal_cursor <strong>into</strong> v_sal;<br />
while emp_sal_cursor%found loop<br />
dbms_output.put_line('salary:'||v_sal);<br />
fetch emp_sal_cursor into v_sal;<br />
end loop;<br />--关闭游标<br /><strong>close</strong> emp_sal_cursor;<br />
end;<br />
可以进行优化如下：</p>
<pre>
declare
v_empid employees.employee_id%type;
v_lastName employees.last_name%type;
v_sal employees.salary%type;
cursor emp_sal_cursor is select employee_id,last_name,salary from employees where
department_id = 80;
begin
open emp_sal_cursor;
fetch emp_sal_cursor into v_empid,v_lastName,v_sal;
while emp_sal_cursor%found loop
dbms_output.put_line('employee_id:'||v_empid||', '||'last_name:'||v_lastName||',
'||'salary:'||v_sal);
fetch emp_sal_cursor into v_empid,v_lastName,v_sal;
end loop;
close emp_sal_cursor;
end;
</pre>
<p>或者使用记录再优化一下：</p>
<pre>
declare
type emp_record is record(
v_empid employees.employee_id%type,
v_lastName employees.last_name%type,
v_sal employees.salary%type
);
v_emp_record emp_record;
cursor emp_sal_cursor is select employee_id,last_name,salary from employees where
department_id = 80;
begin
open emp_sal_cursor;
fetch emp_sal_cursor into v_emp_record;
while emp_sal_cursor%found loop
dbms_output.put_line('employee_id:'||v_emp_record.v_empid||', '||'last_name:'||
v_emp_record.v_lastName||', '||'salary:'||v_emp_record.v_sal);
fetch emp_sal_cursor into v_emp_record;
end loop;
close emp_sal_cursor;
end;
</pre>
<p>可以使用for循环最优化：（注意：在for循环中它会自动的打开游标、提取游标，当提取完里面的数据后也会自动 <br />的关闭游标）</p>
<pre>
declare
cursor emp_sal_cursor is select employee_id,last_name,salary from employees where
department_id = 80;
begin
for c in emp_sal_cursor loop
dbms_output.put_line('employee_id:'||c.employee_id||', '||'last_name:'||c.last_name||',
'||'salary:'||c.salary);
end loop;
end;
</pre>
<p>利用游标，调整公司中员工的工资：<br />
工资范围            调整基数<br />
0 - 5000              5%<br />
5000 - 10000       3%<br />
10000 - 15000     2%<br />
15000 -               1%<br />实现：</p>
<pre>
declare
  cursor emp_cursor is select employee_id,salary from employees;
  v_empid employees.employee_id%type;
  v_sal employees.salary%type;
  v_temp number(4,2);
begin
  open emp_cursor;
  fetch emp_cursor into v_empid,v_sal;
  while emp_cursor%found loop
   if v_sal &lt; 5000 then v_temp:=0.05;
   elsif v_sal &lt; 10000 then v_temp:=0.03;
   elsif v_sal &lt; 15000 then v_temp:=0.02;
   else v_temp:=0.01;
   end if;
  dbms_output.put_line(v_empid||','||v_sal);
  update employees
  set salary = salary * (1+v_temp)
  where employee_id = v_empid;
  fetch emp_cursor into v_empid,v_sal;
  end loop;
  close emp_cursor;
end;
</pre>
<p>用for循环实现</p>
<pre>
declare
  cursor emp_cursor is select employee_id,salary from employees;
  v_temp number(4,2);
begin
  for c in emp_cursor loop
   if c.salary &lt;5000 then v_temp:=0.05;
   elsif c.salary &lt;10000 then v_temp:=0.03;
   elsif c.salary &lt;15000 then v_temp:=0.02;
   else v_temp:=0.01;
  end if;
  update employees
  set salary = salary * (1+v_temp)
  where employee_id = c.employee_id;
  end loop;
end;
</pre>
<p><strong>隐式游标：</strong>更新员工salary（涨工资10），如果该员工没有找到，则打印“查无此人”信息：</p>
<pre>
begin
  update employees
  set salary = salary + 10
  where employee_id = 1001;
   if sql%notfound then dbms_output.put_line('查无此人');
   end if;
end;
</pre>
<p><strong>异常：</strong><br />预定义异常：（有24个预定义异常，可查表）</p>
<pre>
declare
  v_sal employees.salary%type;
begin
  select salary into v_sal from employees
  where employee_id &gt; 100;
  dbms_output.put_line(v_sal);
exception
  when too_many_rows then dbms_output.put_line('输出的行数过多');
  when others then dbms_output.put_line('出现其它的异常了');
end;
</pre>
<p><strong>非预定义异常：</strong></p>
<pre>
declare
  e_deleteid_exception exception;
  pragma exception_init(e_deleteid_exception,-2292);
begin
  delete from employees
  where employee_id = 100;
exception
  when e_deleteid_exception then dbms_output.put_line('违反了完整性约束，故不能删除此用户');
  when others then dbms_output.put_line('出现其它的异常了');
end;
</pre>
<p><strong>用户自定义异常：</strong></p>
<pre>
declare
  e_sal_hight exception;
  v_sal employees.salary%type;
begin
  select salary into v_sal from employees where employee_id = 100;
  if v_sal &gt; 10000 then raise e_sal_hight;
  end if;
exception
  when e_sal_hight then dbms_output.put_line('工资太高了');
  when others then dbms_output.put_line('出现其它的异常了');
end;
</pre>
<p>通过select...into...查询某人的工资，若没找到则打印出“未找到此数据”：</p>
<pre>
declare
  v_sal employees.salary%type;
begin
  select salary into v_sal from employees where employee_id = 1001;
exception
  when no_data_found then dbms_output.put_line('未找到此数据');
  when others then dbms_output.put_line('出现其它的异常了');
end;
更新指定员工工资，如工资小于300，则加100，对NO_DATA_FOUND异常，TOO_MANY_ROWS进行处理。
declare
  v_sal employees.salary%type;
begin
  select salary into v_sal from employees where employee_id = 1001;
  if v_sal &lt; 300 then update employees set salary = salary + 100 where employee_id =101;
  end if;
exception
  when no_data_found then dbms_output.put_line('未找到此数据');
  when too_many_rows then dbms_output.put_line('输出的行数太多了');
  when others then dbms_output.put_line('出现其它的异常了');
end;
</pre>
<p><strong>自定义异常：</strong><br />
更新指定员工工资，增加100；若指定员工不在，则抛出异常：NO_RESULT;</p>
<pre>
declare
  no_result exception;
begin
  update employees set salary = salary + 100 where employee_id = 1001;
  if sql%notfound then raise no_result;
  end if;
exception
  when no_result then dbms_output.put_line('查无此数据,更新失败');
  when others then dbms_output.put_line('出现其它异常');
end;
</pre>
<p><strong>存储过程：</strong><br />
写个简单的hello_world存储函数</p>
<pre>
create or replace function hello_world
return varchar2
is （相当于declare，可以在其后面定义变量、记录、游标）
begin
  return 'helloworld';
end;
存储函数的调用：
begin
  dbms_output.put_line(hello_world);
end;
或者：
select hello_world from dual;
</pre>
<p>带参数的存储函数：</p>
<pre>
create or replace function hello_world1(v_logo varchar2)
return varchar2
is
begin
  return 'helloworld'||v_logo;
end;
调用：
select hello_world1('shellway') from dual
或者：
begin
  dbms_output.put_line(hello_world1('shellway'));
end;
</pre>
<p>定义一个获取系统时间的函数：</p>
<pre>
create or replace function get_sysdate
return varchar2
is
begin
  return to_char(sysdate,'yyyy-MM-dd HH24:mi:ss');
end;
</pre>
<p><strong>定义带参数的函数，两个数相加</strong></p>
<pre>
create or replace function add_param(v_num1 number,v_num2 number)
return number
is
  v_num3 number(10);
begin
  v_num3 := v_num1 + v_num2;
  return v_num3;
end;
调用：
select add_param(2,5) from dual;
或者：
begin
  dbms_output.put_line(add_param(5,4));
end;
</pre>
<p>定义一个函数：获取给定部门的工资总和，要求：部门号定义为参数，工资总额为返回值：</p>
<pre>
create or replace function get_sal(dept_id number)
return number
is
  v_sumsal number(10) := 0;
  cursor salary_cursor is select salary from employees where department_id = dept_id;
begin
  for c in salary_cursor loop
  v_sumsal := v_sumsal + c.salary;
  end loop;
  return v_sumsal;
end;
调用：
select get_sal(80) from dual;
</pre>
<p>定义一个函数：获取给定部门的工资总和 和 该部门的员工总数（定义为<strong>OUT</strong>类型的参数）。<br />
要求：部门号定义为参数，工资总额定义为返回值。</p>
<pre>
create or replace function get_sal(dept_id number,total_count out number)
return number
is
 v_sumsal number(10) := 0;
 cursor salary_cursor is select salary from employees where department_id = dept_id;
begin
  total_count := 0;
  for c in salary_cursor loop
    v_sumsal := v_sumsal + c.salary;
    total_count := total_count + 1;
  end loop;
  return v_sumsal;
end;
调用：
declare
  v_count number(4);
begin
  dbms_output.put_line(get_sal(80,v_count));
  dbms_output.put_line(v_count);
end;
</pre>
<p><strong>定义一个存储过程：</strong>获取给定部门的工资总和（通过out参数），要求部门号和工资总额定义为参数。<br />
（注意：存储过程和存储函数是不一样的，存储函数有返回值而存储过程没有，调用时候存储过程直接调用）</p>
<pre>
create or replace procedure get_sal1(dept_id number,sumsal out number)
is
 cursor salary_cursor is select salary from employees where department_id = dept_id;
begin
 sumsal := 0;
 for c in salary_cursor loop
   sumsal := sumsal + c.salary;
 end loop;
 dbms_output.put_line(sumsal);
end;
调用：
declare
  v_sal number(10):=0;
begin
 get_sal1(80,v_sal);
end;
</pre>
<p>对给定部门（作为输入参数）的员工进行加薪操作，若其到公司的时间在（？，95）期间，为其加薪5%</p>
<p>                                                                                          （95，98）                  3%</p>
<p>                                                                                          （98，？）                   1%<br />
得到以下返回结果：为此次加薪公司每月额外付出多少成三（定义一个OUT型的输出参数）</p>
<pre>
create or replace procedure add_sal(dept_id number,temp out number)
is
  cursor sal_cursor is select employee_id,salary,hire_date
  from employees where department_id = dept_id;
  v_temp number(4,2):=0;
begin
  temp := 0;
  for c in sal_cursor loop
    if to_char(c.hire_date,'yyyy') &lt; '1995' then v_temp:=0.05;
    elsif to_char(c.hire_date,'yyyy') &lt; '1998' then v_temp:=0.03;
    else v_temp:=0.01;
    end if;

  update employees
  set salary = salary * (1+v_temp)
  where employee_id = c.employee_id;

  temp := temp + c.salary*v_temp;
  end loop;
  dbms_output.put_line(temp);
end;
调用：
declare
  v_i number(10):=0;
begin
  add_sal(80,v_i);
end;
</pre>
<p><strong>触发器：</strong><br /><strong>触发事件</strong>：在INSERT,UPDATE,DELETE情况下会触发TRIGGER<br /><strong>触发时间：</strong>该TRIGGER是在触发事件发生之前(BEFORE)还是之后（AFTER）<br /><strong>触发器本身：</strong>该TRIGGER被触发之后的目的和意图，正是触发器本身要做的事情，如PL/SQL块<br /><strong>触发频率：</strong>有语句级(STATEMENT)触发器和行级(ROW)触发器<br />
写一个简单的触发器：</p>
<pre>
create or replace trigger update_emp_trigger
after
  update on employees
for each row (行级触发器，即每更新一条记录就会输出一次'helloworld'，若没有这语句则是语句级触发器)
begin
  dbms_output.put_line('helloworld');
end;
</pre>
<p><strong>使用:new,:old修饰符：</strong></p>
<pre>
1、
create table emp1
as
select employee_id,salary,email from employees where department_id = 80;
2、
create or replace trigger update_emp_trigger2
after
  update on emp1
for each row
begin
  dbms_output.put_line('old salary:'||:old.salary||'new salary:'||:new.salary);
end;
3、
update emp1 set salary = salary + 100 ；
</pre>
<p>编写一个触发器，在对my_emp记录进行删除的时候，在my_emp_bak表中备份对应的记录</p>
<pre>
1、创建my_emp表：
create table my_emp
as
select employee_id,salary from employees ;
2、创建my_emp_bak表：
create table my_emp_bak
as
select employee_id,salary from employees where 1=2;
3、检查创建的表中的记录：
select * from my_emp
select * from my_emp_bak
4、创建一个触发器：
create or replace trigger delete_emp_trigger
before
  delete on my_emp
for each row
begin
  insert into my_emp_bak
  values(:old.employee_id,:old.salary);
end;
5、执行含有触发器时间的语句：
delete from my_emp
6、检查触发器执行后的结果：
select * from my_emp
select * from my_emp_bak</pre>
<p>以上是小编为您精心准备的的内容，在的博客、问答、公众号、人物、课程等栏目也有的相关内容，欢迎继续使用右上角搜索按钮进行搜索oracle<br />
                    ，                pl/sql<br />
                    ，                触发器<br />
                    ，                流程控制<br />
                    ，                基本语法<br />
                    ，                记录类型<br />
                    ，                游标的使用<br />
                                    异常处理机制<br />
                                    ，以便于您获取更多的相关知识。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-25 06:54:27</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/oracle/" title="oracle">oracle</a>, <a href="https://www.iamivan.net/tag/%e8%a7%a6%e5%8f%91%e5%99%a8/" title="触发器">触发器</a>, <a href="https://www.iamivan.net/tag/pl-sql/" title="pl&sol;sql">pl&sol;sql</a>, <a href="https://www.iamivan.net/tag/%e8%ae%b0%e5%bd%95%e7%b1%bb%e5%9e%8b/" title="记录类型">记录类型</a>, <a href="https://www.iamivan.net/tag/%e6%b8%b8%e6%a0%87%e7%9a%84%e4%bd%bf%e7%94%a8/" title="游标的使用">游标的使用</a>, <a href="https://www.iamivan.net/tag/%e5%bc%82%e5%b8%b8%e5%a4%84%e7%90%86%e6%9c%ba%e5%88%b6/" title="异常处理机制">异常处理机制</a>, <a href="https://www.iamivan.net/tag/%e6%b5%81%e7%a8%8b%e6%8e%a7%e5%88%b6/" title="流程控制">流程控制</a>, <a href="https://www.iamivan.net/tag/%e5%9f%ba%e6%9c%ac%e8%af%ad%e6%b3%95/" title="基本语法">基本语法</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>oracle复习笔记之PL/SQL程序所要了解的知识点_oracle的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MrD1o4z.html" rel="bookmark">Oracle数据库之PL&sol;SQL程序基础设计</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.PL/SQL块结构 前边我们已经介绍了PL/SQL块的结构,再来回顾一下: DECLARE /* * 声明部分--定义常量.变量.复杂数据类型.游标.用户自定义异常 */ BEGIN /* * 执行部分--PL/SQL语句和SQL语句 */ EXCEPTION /* * 异常处理部分--处理运行异常 */ END; /*块结束标记 */ 要实现PL/SQL程序设计,先介绍如下的基本内容: 二.标识符 PL/SQL程序设计中的标识符定义与SQL的标识符定义的要求相同: 标识符名第一个字符必须为			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/ybjjPnb.html" rel="bookmark">写PL&sol;SQL程序时碰到的一些问题</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				程序|问题 记的上次写PL/SQL程序还是刚毕业不久,还用的是Oracle 7 for Novell后来只是偶尔用一下oralce, PL/SQL的一些语法已经全忘了,这不,碰到好些低级的问题,谨记下,希望不会再忘记. 1.有for update类型的Cursor定义Cursor时,加了for update,因为需要打开cursor后还要对这些数据进行修改和删除,但在修改和删除数据后在关闭cursor前就commit,就出现了下面的错误:ORA-01002: 读取违反顺序ORA-06512: 在			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Nz7ogRz.html" rel="bookmark">PL&sol;SQL程序结构</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				什么是PL/SQL程序     前面第4章学习的标准化的SQL语言对数据库进行各种操作,每次只能执行一条语句,语句以英文的分号&quot;;&quot;为结束标识,这样使用起来很不方便,同时效率较低,这是因为Oracle数据库系统不像VB.VC这样的程序设计语言,它侧重于后台数据库的管理,因此提供的编程能力较弱,而结构化编程语言对数据库的支持能力又较弱,如果一些稍微复杂点的管理任务都要借助编程语言来实现的话,这对管理员来讲是很大的负担.    正是在这种需求的驱使下,从Oracle 6开始,Oracle公			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zeaZ09z.html" rel="bookmark">Oracle数据库之开发PL&sol;SQL子程序和包</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				PL/SQL块分为匿名块与命名块,命名块又包含子程序.包和触发器. 过程和函数统称为PL/SQL子程序,我们可以将商业逻辑.企业规则写成过程或函数保存到数据库中,以便共享. 过程和函数均存储在数据库中,并通过参数与其调用者交换信息.过程和函数的唯一区别是函数总向调用者返回数据,而过程不返回数据. 1. 存储过程概念 存储过程(Stored Procedure)是在大型数据库系统中,一组为了完成特定功能的SQL语句集,存储在数据库中.经过第一次编译后再次调用不需要再次编译,用户通过指定存储过程的名			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pn8Kj0b.html" rel="bookmark">Oracle 10G&colon;PL&sol;SQL正规表达式（正则表达式）手册&lowbar;oracle</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Oracle 的正规表达式的实施是以各种 SQL 函数和一个 WHERE 子句操作符的形式出现的.如果您不熟悉正规表达式,那么这篇文章可以让您了解一下这种新的极其强大然而表面上有点神秘的功能.已经对正规表达式很熟悉的读者可以了解如何在 Oracle SQL 语言的环境中应用这种功能. 什么是正规表达式? 正规表达式由一个或多个字符型文字和/或元字符组成.在最简单的格式下,正规表达式仅由字符文字组成,如正规表达式 cat.它被读作字母 c,接着是字母 a 和 t,这种模式匹配 cat.locati			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/2MWoeAM.html" rel="bookmark">pl&sol;sql程序编写中遇到的一些问题及解决办法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				程序|解决|问题 1.在pl/sql中,order by子句中的条件可以使用变量! DECLARE v_orderbystr VARCHAR2(30); v_userid VARCHAR2(30); v_username VARCHAR2(30); v_gender NUMBER; v_rownum NUMBER; TYPE tcur IS REF CURSOR; results tcur; BEGIN v_rownum:=0; v_orderbystr:='username';    OPEN			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/VzwN9Rp.html" rel="bookmark">实用的备份PL&sol;SQL程序工具</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				备份|程序 /*ligang1000@hotmail.com*/   功能: 用于备份当前用户所拥有的所有PL/SQL objects (包括 TYPE,TYPE BODY, PROCEDURE , FUNCTION, PACKAGE, PACKAGE BODY or JAVA SOURCE )   原理: 对USER_SOURCE数据字典的调用,得到所有的 PL/SQL 代码.   使用方法举例: 1.     在C盘建立目录C:\EXPORT 2.     将EXPORT_SOURCE.SQ			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M19DmaM.html" rel="bookmark">PL&sol;SQL程序中调用Java代码（转）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				  主要是学习PL/SQL调用JAVA的方法. 平台:WINDOWS 1.首先使用IDE写好需要调用的java代码,再添加&quot;create or replace and compile java source named 名字 as&quot;,然后在PL/SQL中执行   create or replace and compile java source named getosmac as import java.io.InputStreamReader; import java.io.Line			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bEQv6qb.html" rel="bookmark">PL&sol;SQL学习笔记&lpar;三&rpar; &mdash;&mdash;PL&sol;SQL代码编写规则</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				养成良好的代码编写习惯,PL/SQL代码编写规则: 1.标识符命名规则 1)定义变量时以v_作为前缀,如v_sal 2)定义常量时以c_作为前缀,如c_rate 3)定义游标时,建议使用_cursor作为后缀,如emp_cursor 4)定义异常时,以e_作为前缀,如e_integrity_error 5)定义PL/SQL表类型时,使用_table_type作为后缀,如sal_table_type. 6)定义表变量时,以_table作为后缀,如sal_table 7)同样,定义PL/SQL记录型			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/VMrvnVM.html" rel="bookmark" class="title">EXE和DLL中FindResource的区别</a>
					<div>
						以下的代码在EXE中,执行无误.可是在DLL中FindResource返回的值就为0了,我用::GetLastError(),得出的值是1813,也就是取不到资源,这是为什么? BOOL Extrac ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/7b29gkz.html" rel="bookmark" class="title">高分辨率下界面布局的解决方案</a>
					<div>
						分辨率|解决 高分辨率下文字字体.图像.界面布局的解决方案 为什么要保证我们的软件产品或应用程序中的文本.图像和字体.布局等问题呢,因为我们用户的终端显示设备通常型号和设置各异,如最近出现的16×9, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/OM9Qd4M.html" rel="bookmark" class="title">数据导出脚本示例 export&period;par</a>
					<div>
						脚本|示例|数据 FULL=YROWS=YINDEXES=YGRANTS=YCONSTRAINTS=YCONSISTENT=YDIRECT=YBUFFER=2000000File=/backup/db ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/7b2Xeop.html" rel="bookmark" class="title">解密网站收录量与权重排名的微妙关系</a>
					<div>
						在交换友情链接的时候,很多站长特别在意对方网站被收录了多少页面,仅仅从收录数量来定论一个网站权重的高低,来决定链接交换的首要依据,那是非常偏激的.在实际的观察中发现了很多案例,许多高权重的网站(大多是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/lpPElZz.html" rel="bookmark" class="title">带你轻松接触Sybase备份软件的插件模块</a>
					<div>
						Sybase插件模块 : 随着Sybase应用大小和数量的增长,越来越需要保护这些重要企业资产的可靠而且使用简单的解决方案.Sybase插件模块通过快速在线备份Sybase数据库,提高了应用的可用性. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvKA2Wp.html" rel="bookmark" class="title">PS绘制游戏UI魔力药水瓶教程</a>
					<div>
						  本次教程主要表现一下透明玻璃质感,在游戏中比较常见的玻璃体就是魔法瓶了. 所以出一个魔力药水的教程,希望能对新人有帮助. 分类: PS鼠绘教程					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlRyk8z.html" rel="bookmark" class="title">PS制作古典美女古风溶图签名图教程</a>
					<div>
						教程教大家用PS制作漂亮的古典美女古风签名图,喜欢的同学一起来学习吧! 所谓溶图其实就是用Photoshop除抠图之外给人物替换背景的另一种演变.但它的形式又完全不同于抠图.抠图所追求的是极致的精益求 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0WQR7b.html" rel="bookmark" class="title">电脑COM Surrogate已经停止工作怎么办</a>
					<div>
						  关于32位win7的操作办法 最近一个礼拜,每次打开我的视频文件夹时,总是会弹出一个错误框,提示COM Surrogate已经停止工作,或是Explorer已经停止工作,需要重启,虽然不影响使用, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mr3yx6p.html" rel="bookmark" class="title">必应输入法怎么样&quest;</a>
					<div>
						现在电脑上用五笔的朋友估计越来越少了,好的拼音输入法也是难求,搜狗拼音现在也是越来越庞大,各种广告特多,&quot;必应输入法&quot;的前身&quot;英库拼音输入法&quot;来自微软亚洲研究院 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwLdPkb.html" rel="bookmark" class="title">C&num;点灯神话</a>
					<div>
						如同学习每一门编程语言的Hello World!一样,点灯自然成了单片机入门的HelloWorld.因为单片机上的HelloWorld实在是太难了! 在电子上只有电压电流之类的概念,而对于单片机来说, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mg3xk8M.html" rel="bookmark" class="title">apache下实现301永久性重定向的方法</a>
					<div>
						因为博客是使用了www.jzread.com作为博客域名,所以想实现jzread.com全部重定向(跳转)到www.jzread.com.同时按照google的建议,使用服务器端 301 重定向,为了 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bama4Qb.html" rel="bookmark" class="title">个人检查php-fpm</a>
					<div>
						!/bin/bash check php-fpm server up/down while : do sleep 15; /usr/bin/curl https://api.itboye.com/pu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJk2kVb.html" rel="bookmark" class="title">可独立开发 满足自身特定需求的通用图像分析服务</a>
					<div>
						通用图像分析服务是一款提供图像内容分析和理解的在线服务产品,它采用了先进的深度学习算法和海量的学习样本解决色情图像识别的问题. &quot;通用&quot;一词是指,在该服务中提供的算法API模块可以 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/My3ZvZz.html" rel="bookmark" class="title">三层架构详解（服务员-厨师-采购员）</a>
					<div>
						三层架构详解 1,什么是三层? 2,为什么使用三层? 3,三层与以往使用的两层相比有什么不同?它的优势在哪里? 4,如何学好三层?如何应用三层? -- 对于三层我左思右想,如何与实际相联系.好嘛,昨晚 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bamGOnb.html" rel="bookmark" class="title">java中常量可以用来干什么啊，是仅仅作为方法的参数吗，</a>
					<div>
						问题描述 java中常量可以用来干什么啊,是仅仅作为方法的参数吗, java中常量可以用来干什么啊,是仅仅作为方法的参数吗,不同的类可以调用同一个常量吗 解决方案 变量,是做数据保存用的.方法的参数, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boRV6gz.html" rel="bookmark" class="title">initWithFormat 和stringWithFormat的区别</a>
					<div>
						差别: 1.initWithFormat是实例办法 只能经由过程 NSString* str = [[NSString alloc] initWithFormat:@&quot;%@&quot;,@& ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MAAw8vM.html" rel="bookmark" class="title">怎么设置listview标题的高度，有图</a>
					<div>
						问题描述 下图右边是dataGridview,左边是listview我想把listview的标题高度设置成和dataGridview一样 解决方案 解决方案二:http://stackoverflow ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnKXBkz.html" rel="bookmark" class="title">界面-酷安首页那个下滑之后 把内容扩展的效果怎么做的</a>
					<div>
						问题描述 酷安首页那个下滑之后 把内容扩展的效果怎么做的 下滑之后 按钮就缩为四个小按钮 解决方案 百度一下,应该会知道 解决方案二: 不清楚你要怎样的效果,不过大致可以给你些思路.你需要的效果,需要 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mvm3LVb.html" rel="bookmark" class="title">批处理实现的结束进程并删除文件的代码&lowbar;DOS&sol;BAT</a>
					<div>
						复制代码 代码如下: @echo off title=结束进程并删除文件[Null] echo.请输入进程名: set /p exe= For /f &quot;tokens=2,3 delims=, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2RGoQb.html" rel="bookmark" class="title">JAVA中的观察者模式实例教程</a>
					<div>
						观察者模式是一种行为设计模式.观察者模式的用途是,当你对一个对象的状态感兴趣,希望在它每次发生变化时获得通知.在观察者模式中,观察另外一个对象状态的对象叫做Observer观察者,被观察的对象叫着Su ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlKk9ab.html" rel="bookmark" class="title">C&plus;&plus;在C语言基础之上增强的几个实用特性总结&lowbar;C 语言</a>
					<div>
						变量的定义 C语言中的变量都必须在作用域开始的位置定义!!  C++中更强调语言的&quot;实用性&quot;,所有的变量都可以在需要使用时再定义.  #include &lt;iostream&g ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Myd6llb.html" rel="bookmark" class="title">wpf WebBrowser session丢失</a>
					<div>
						问题描述 做了一个简单的在wpf的window中打开网页的程序.代码也仅仅写了一句,就是WebBrowser.NaNavigate();可以正常打开第一页.web是其他人的东西.web的页面中有一个按 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1rVqdp.html" rel="bookmark" class="title">代码-如何在显示模态框的同时触发OnClick</a>
					<div>
						问题描述 如何在显示模态框的同时触发OnClick 用VS 2013 for web 作了一个网页,用于后台计算,然后把结果显示到网页上.由于运行时间较长,希望在点击按钮后显示一个Bootstrap模 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOmZE9M.html" rel="bookmark" class="title">北京五月前完成公厕位置手机查询信息系统</a>
					<div>
						记者从昨天的北京市环境卫生工作总结交流会上了解到,&quot;五一&quot;节前,本市将完成公厕位置手机查询http://www.aliyun.com/zixun/aggregation/32730 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPkBR0M.html" rel="bookmark" class="title">AWS Amazon系列--VPC安装教程一</a>
					<div>
						相信大家都用过Amazon的EC2服务,但估计知道VPC的不是很多,我们来看看官方的介绍: Amazon Virtual Private Cloud (Amazon VPC) lets you pro ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYXyx9b.html" rel="bookmark" class="title">chrome-IE设置导致CEF3打开网页速度慢</a>
					<div>
						问题描述 IE设置导致CEF3打开网页速度慢 由于IE设置的局域网设置中&quot;自动检测设置&quot;被勾选,导致chrome CEF3嵌入的网页第一次加载非常慢,大神们有没有好的解决方法呢?					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRNoekM.html" rel="bookmark" class="title">设计模式：组合模式（Composite）</a>
					<div>
						将对象组合成属性结构以表示&quot;部分-整体&quot;的层次结构.组合使得用户和单个对象和组合对象的使用具有一致性. 组合模式设计的角色: 1. Component:是组合中的对象声明接口,在适 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z444qLz.html" rel="bookmark" class="title">一次nginx 504 Gateway Time-out错误排查、解决记录&lowbar;nginx</a>
					<div>
						记一次莫名其妙的网站失去响应排查.之前网站一直是使用nginx做代理后端的apache运行php来提供服务.apache经常会不定期不定时间的出现不能服务失去响应,然后nginx出现&quot;504 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZ2XOkz.html" rel="bookmark" class="title">html5-HTML5中video标签可用的流媒体服务器是什么</a>
					<div>
						问题描述 HTML5中video标签可用的流媒体服务器是什么 我要做一个基于HTML5的视频播放网站,虽然video支持边下边播,但是老师还是要我搭建流媒体服务器来存放视频,我试过Helix Serv ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlmqKqp.html" rel="bookmark" class="title">关于自动关机命令</a>
					<div>
						问题描述 相信很多人都用过Shutdown-s命令来关机吧.我想问一下,为什么我写成&quot;at14:30Shutdown-s&quot;或者&quot;at14:30Shutdown-s-t10 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 12 q. 0.033 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
